<template>
  <div>
    <tait-form :fields="fields" :url="url" :create="id ? false : true"></tait-form>
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import axios from "axios";

import taitFrom from '@/components/Form.vue';
import { BASE_URL, options } from "@/utils";
import type { IpPoolsType } from "@/types";

export default defineComponent({
  components: {
    "tait-form": taitFrom
  },

  props: {
    id: {
      type: String,
      default: ""
    }
  },

  data() {
    return {
      url: "/testdata",
      create: true,
      fields: [
        { field: 'unitId', header: 'Unit ID', type: "hex", combo: { key: 'suid', location: 8 }, size: 6, editable: true, defaultValue: "000001" },
        { field: 'systemId', header: 'System ID', type: "hex", combo: { key: 'suid', location: 5 }, size: 3, editable: true },
        { field: 'wacnId', header: 'WACN ID', type: "hex", combo: { key: 'suid', location: 0 }, size: 5, editable: true },
        { field: 'suid', header: 'SUID', type: "combo", size: 14, editable: true },
        { field: 'wuid', header: 'WUID', type: "text", editable: false },
        { field: 'alias', header: 'Alias', type: "text", editable: true },
        {
          field: 'type', header: 'Type', type: "dropdown", defaultValue: 0,
          options: options.subscriberType,
          editable: true
        },
        {
          field: 'unitType', header: 'Unit Type', type: "dropdown", defaultValue: 0,
          options: options.subscriberUnit,
          editable: true
        },
        {
          field: 'status', header: 'Status', type: "dropdown",
          options: options.subscriberStatus,
          editable: false
        },
        { field: 'locationId', header: 'Location ID', type: "text", editable: false },
        { field: 'lastRegistration', header: 'Last Registration', type: "date", editable: false },
        { field: 'expires', header: 'Expires', type: "text", editable: false },
        { field: 'inhibited', header: 'Inhibited', type: "binary", editable: false },
        {
          field: 'priority', header: 'Priority', type: "dropdown", defaultValue: 5,
          options: options.priority,
          editable: true
        },
        {
          field: 'visitor', header: 'Visitor', type: "binary", editable: false
        },
        {
          field: 'groupCallPerm', header: 'Group Call Perm.', type: "dropdown", defaultValue: 3,
          options: options.callPermission,
          editable: true
        },
        {
          field: 'unitCallPerm', header: 'Unit Call Perm.', type: "dropdown", defaultValue: 3,
          options: options.callPermission,
          editable: true
        },
        {
          field: 'pstnCallPerm', header: 'PSTN Call Perm.', type: "dropdown", defaultValue: 3,
          options: options.callPermission,
          editable: true
        },
        {
          field: 'systemCallPerm', header: 'System Call Perm.', type: "dropdown", defaultValue: 0,
          dependentFields: {
            matchAll: false,
            dependsOn: [{ name: "unitType", validValues: [1, 2] }, { name: "type", validValues: [2] }]
          },
          options: [{ "name": "None", "value": 0 }, { "name": "All", "value": 1 }], editable: true
        },
        {
          field: 'vocoderMode', header: 'Vocoder Mode', type: "dropdown",
          options: options.vocoder,
          editable: false
        },
        { field: 'allowDataCalls', header: 'Allow Data Calls', type: "binary", editable: true },
        {
          field: 'ipPool', header: 'IP Pool', type: "ipPools", secondaryField: "staticIpAddress",
          dependentFields: {
            matchAll: false,
            dependsOn: [{ name: "allowDataCalls", validValues: [true, 1] }]
          },
          ipPools: ["Test", "Example", "Pools"], // This will we filled by the server
          editable: true
        },
      ]
    };
  }
});
</script>
